;; Exercitiul 1 - identificati unde in lab2-rezolvat
;; am folosit let* si daca se putea folosi in loc 
;; let, letrec sau named let
(define (take-and-drop n L)
  (tad-helper n L '()))

(define (tad-helper n L Taken)
  (if (or (null? L) (<= n 0))
      (cons (reverse Taken) L)
      (tad-helper (- n 1) (cdr L) (cons (car L) Taken))))

(define (split-to-sublists L k)
  (sts-helper L k '()))

;; let* apare AICI
(define (sts-helper L k Result)
  (if (null? L)
      (reverse Result)
      (let* ((TaD (take-and-drop k L))
             (Taken (car TaD))
             (Dropped (cdr TaD)))
        (sts-helper Dropped k (cons Taken Result)))))

;(split-to-sublists '(1 2 3 4 5 6 7 8 9 10) 4)

;; ce puteam folosi?
;; let - NU
;; intrucat (Taken (car TaD)) nu ar fi stiut cine e TaD

;; letrec - DA
;; intrucat toate variabilele ar fi fost vizibile in tot letrec-ul,
;; inclusiv TaD in zona de definitie a lui Taken

;; named let - NU
;; named let e o varianta de let
;; nu exista named let* sau named letrec

;; inlocuiti let* in codul de mai sus pentru a verifica aceste aspecte
;; ce parere aveti despre let* din a 2a varianta de split-to-sublists?

;; Discutie:
;; fara let, ar fi trebuit sa folosim 
;; (car (take-and-drop k L)) pe post de Taken si
;; (cdr (take-and-drop k L)) pe post de Dropped,
;; adica sa evaluam de 2 ori expresia (take-and-drop k L),
;; ceea ce ar fi fost foarte ineficient

;; Exercitiul 2 - implementarea lui fibonacci iterativ folosind un named let
(define (fibo n)
  (let iter ((n n) (fst 0) (snd 1))
    (if (zero? n)
        fst
        (iter (sub1 n) snd (+ fst snd)))))

;(map fibo '(0 1 2 3 4 5 6 7 8 9 10))

;; Observatie
;; - apare expresia (let iter ((n n) ... )
;; - aceasta inseamna ca variabila n locala let-ului este initializata
;;   cu variabila n din exterior; deci n-ul interior pleaca cu valoarea
;;   pasata lui fibo, dupa care descreste, ceea ce nu afecteaza cu nimic
;;   n-ul exterior
;; - pentru a va convinge puteti incerca exemplul de mai jos
;; - cautati in help desk semnificatia lui begin, apoi nu il mai folositi
;;   niciodata altfel decat pt debug sau pretty print
(define (fibo2 n)
  (begin
    (let iter ((n n) (fst 0) (snd 1))
      (printf "local n = ~a. " n) ; afiseaza n-ul local let-ului
      (if (zero? n)
          fst
          (iter (sub1 n) snd (+ fst snd)))) 
    (printf "~nexterior n = ~a.~n" n))) ; afiseaza n-ul exterior

(map fibo2 '(0 1 2))



